package com.kezhilian.flutter_get_sn;

import android.os.Build;

import java.lang.reflect.Method;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** FlutterGetSnPlugin */
public class FlutterGetSnPlugin implements MethodCallHandler {
  private static int VERSION_N = 24;

  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "flutter_get_sn");
    channel.setMethodCallHandler(new FlutterGetSnPlugin());
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("getSn")) {
      String sn = getSmSnInfo();
      result.success(sn);
    } else result.notImplemented();
  }

  public String getSmSnInfo() {
    String smSn;
    try {
      if (Build.VERSION.SDK_INT > VERSION_N) {
        smSn = Build.SERIAL;
      } else {
        Class c = Class.forName("android.os.SystemProperties");
        Method get = c.getMethod("get", String.class);
        // 获取SN码
        smSn = (String) get.invoke(c, "ro.serialno");
      }
    } catch (Exception e) {
      e.printStackTrace();
      smSn = "";
    }
    return smSn;
  }
}
